/* lockable.c generated by valac 0.56.17, the Vala compiler
 * generated from lockable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType seahorse_lockable_get_type_once (void);

void
seahorse_lockable_lock (SeahorseLockable* self,
                        GTlsInteraction* interaction,
                        GCancellable* cancellable,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	SeahorseLockableIface* _iface_;
#line 22 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 22 "../common/lockable.vala"
	if (_iface_->lock) {
#line 22 "../common/lockable.vala"
		_iface_->lock (self, interaction, cancellable, _callback_, _user_data_);
#line 54 "lockable.c"
	}
}

gboolean
seahorse_lockable_lock_finish (SeahorseLockable* self,
                               GAsyncResult* _res_,
                               GError** error)
{
	SeahorseLockableIface* _iface_;
#line 22 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 22 "../common/lockable.vala"
	if (_iface_->lock_finish) {
#line 22 "../common/lockable.vala"
		return _iface_->lock_finish (self, _res_, error);
#line 70 "lockable.c"
	}
#line 22 "../common/lockable.vala"
	return FALSE;
#line 74 "lockable.c"
}

void
seahorse_lockable_unlock (SeahorseLockable* self,
                          GTlsInteraction* interaction,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	SeahorseLockableIface* _iface_;
#line 22 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 22 "../common/lockable.vala"
	if (_iface_->unlock) {
#line 22 "../common/lockable.vala"
		_iface_->unlock (self, interaction, cancellable, _callback_, _user_data_);
#line 91 "lockable.c"
	}
}

gboolean
seahorse_lockable_unlock_finish (SeahorseLockable* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	SeahorseLockableIface* _iface_;
#line 22 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 22 "../common/lockable.vala"
	if (_iface_->unlock_finish) {
#line 22 "../common/lockable.vala"
		return _iface_->unlock_finish (self, _res_, error);
#line 107 "lockable.c"
	}
#line 22 "../common/lockable.vala"
	return FALSE;
#line 111 "lockable.c"
}

gboolean
seahorse_lockable_can_lock (GObject* object)
{
	gboolean result;
#line 32 "../common/lockable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 33 "../common/lockable.vala"
	if (SEAHORSE_IS_LOCKABLE (object)) {
#line 122 "lockable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 34 "../common/lockable.vala"
		_tmp0_ = seahorse_lockable_get_lockable (G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_LOCKABLE, SeahorseLockable));
#line 34 "../common/lockable.vala"
		_tmp1_ = _tmp0_;
#line 34 "../common/lockable.vala"
		result = _tmp1_;
#line 34 "../common/lockable.vala"
		return result;
#line 133 "lockable.c"
	}
#line 35 "../common/lockable.vala"
	result = FALSE;
#line 35 "../common/lockable.vala"
	return result;
#line 139 "lockable.c"
}

gboolean
seahorse_lockable_can_unlock (GObject* object)
{
	gboolean result;
#line 38 "../common/lockable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 39 "../common/lockable.vala"
	if (SEAHORSE_IS_LOCKABLE (object)) {
#line 150 "lockable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 40 "../common/lockable.vala"
		_tmp0_ = seahorse_lockable_get_unlockable (G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_LOCKABLE, SeahorseLockable));
#line 40 "../common/lockable.vala"
		_tmp1_ = _tmp0_;
#line 40 "../common/lockable.vala"
		result = _tmp1_;
#line 40 "../common/lockable.vala"
		return result;
#line 161 "lockable.c"
	}
#line 41 "../common/lockable.vala"
	result = FALSE;
#line 41 "../common/lockable.vala"
	return result;
#line 167 "lockable.c"
}

gboolean
seahorse_lockable_get_lockable (SeahorseLockable* self)
{
	SeahorseLockableIface* _iface_;
#line 23 "../common/lockable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 23 "../common/lockable.vala"
	if (_iface_->get_lockable) {
#line 23 "../common/lockable.vala"
		return _iface_->get_lockable (self);
#line 182 "lockable.c"
	}
#line 23 "../common/lockable.vala"
	return FALSE;
#line 186 "lockable.c"
}

gboolean
seahorse_lockable_get_unlockable (SeahorseLockable* self)
{
	SeahorseLockableIface* _iface_;
#line 24 "../common/lockable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../common/lockable.vala"
	_iface_ = SEAHORSE_LOCKABLE_GET_INTERFACE (self);
#line 24 "../common/lockable.vala"
	if (_iface_->get_unlockable) {
#line 24 "../common/lockable.vala"
		return _iface_->get_unlockable (self);
#line 201 "lockable.c"
	}
#line 24 "../common/lockable.vala"
	return FALSE;
#line 205 "lockable.c"
}

static void
seahorse_lockable_default_init (SeahorseLockableIface * iface,
                                gpointer iface_data)
{
#line 22 "../common/lockable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("lockable", "lockable", "lockable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../common/lockable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("unlockable", "unlockable", "unlockable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 216 "lockable.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_lockable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseLockableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_lockable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_lockable_type_id;
	seahorse_lockable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseLockable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_lockable_type_id, G_TYPE_OBJECT);
	return seahorse_lockable_type_id;
}

GType
seahorse_lockable_get_type (void)
{
	static volatile gsize seahorse_lockable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_lockable_type_id__once)) {
		GType seahorse_lockable_type_id;
		seahorse_lockable_type_id = seahorse_lockable_get_type_once ();
		g_once_init_leave (&seahorse_lockable_type_id__once, seahorse_lockable_type_id);
	}
	return seahorse_lockable_type_id__once;
}

