/* source.c generated by valac 0.56.17, the Vala compiler
 * generated from source.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004-2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (c) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include "seahorse-common.h"
#include <gcr/gcr-base.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_SSH_SOURCE_0_PROPERTY,
	SEAHORSE_SSH_SOURCE_LABEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY,
	SEAHORSE_SSH_SOURCE_URI_PROPERTY,
	SEAHORSE_SSH_SOURCE_ICON_PROPERTY,
	SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY,
	SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY,
	SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorseSshSourceAddKeyFromFilenameData SeahorseSshSourceAddKeyFromFilenameData;
typedef struct _SeahorseSshSourceLoadKeyForPrivateFileData SeahorseSshSourceLoadKeyForPrivateFileData;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
typedef struct _SeahorseSshSourceLoadData SeahorseSshSourceLoadData;
typedef struct _SeahorseSshSourceImportAsyncData SeahorseSshSourceImportAsyncData;
typedef struct _SeahorseSshSourceImportPublicAsyncData SeahorseSshSourceImportPublicAsyncData;
typedef struct _Block8Data Block8Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _SeahorseSshSourceAuthorizeAsyncData SeahorseSshSourceAuthorizeAsyncData;

struct _SeahorseSshSourcePrivate {
	gchar* ssh_homedir;
	guint scheduled_refresh_source;
	GFileMonitor* monitor_handle;
	GListStore* keys;
};

struct _SeahorseSshSourceAddKeyFromFilenameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	guint i;
	gboolean _tmp0_;
	guint _tmp1_;
	GListStore* _tmp2_;
	SeahorseSshKey* key;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	SeahorseSshKey* _tmp5_;
	SeahorseSshKeyData* _tmp6_;
	SeahorseSshKeyData* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	SeahorseSshKey* _tmp10_;
	SeahorseSshKey* _tmp11_;
	SeahorseSshKey* _tmp12_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceLoadKeyForPrivateFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	gchar* pubfile;
	gchar* _tmp0_;
	SeahorseSshKey* key;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	SeahorseSshKeyKeyParseResult _result_;
	const gchar* _tmp4_;
	SeahorseSshKeyKeyParseResult _tmp5_;
	SeahorseSshKeyKeyParseResult _tmp6_;
	SeahorseSshKeyData** _tmp7_;
	gint _tmp7__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp8_;
	const gchar* _tmp9_;
	SeahorseSshKey* _tmp10_;
	GError* e;
	const gchar* _tmp11_;
	GError* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GError* _tmp16_;
	GError* _tmp17_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GCancellable* cancellable;
	gboolean result;
	GDir* dir;
	const gchar* _tmp0_;
	GDir* _tmp1_;
	gchar* filename;
	GDir* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* privfile;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* pubfile;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	SeahorseSshKeyKeyParseResult _result_;
	const gchar* _tmp12_;
	SeahorseSshKeyKeyParseResult _tmp13_;
	SeahorseSshKeyKeyParseResult _tmp14_;
	SeahorseSshKeyData** _tmp15_;
	gint _tmp15__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp16_;
	const gchar* _tmp17_;
	SeahorseSshKey* _tmp18_;
	SeahorseSshKey* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	SeahorseSshKeyKeyParseResult _vala1__result_;
	const gchar* _tmp22_;
	SeahorseSshKeyKeyParseResult _tmp23_;
	SeahorseSshKeyKeyParseResult _tmp24_;
	SeahorseSshKeyData** _tmp25_;
	gint _tmp25__length1;
	SeahorseSshKeyData** _vala1_keydata_collection;
	gint _vala1_keydata_collection_length1;
	gint __vala1_keydata_collection_size_;
	gint _vala1_keydata_it;
	SeahorseSshKeyData* _vala1_keydata;
	SeahorseSshKeyData* _tmp26_;
	const gchar* _tmp27_;
	SeahorseSshKey* _tmp28_;
	SeahorseSshKey* _tmp29_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceImportAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GInputStream* input;
	GtkWindow* transient_for;
	GCancellable* cancellable;
	GList* result;
	SeahorseSshKeyKeyParseResult _result_;
	SeahorseSshKeyKeyParseResult _tmp0_;
	gchar* fullpath;
	gchar* _tmp1_;
	SeahorseSshKeyKeyParseResult _tmp2_;
	SeahorseSshKeyData** _tmp3_;
	gint _tmp3__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	SeahorseSshKeyKeyParseResult _tmp8_;
	SeahorseSshSecData** _tmp9_;
	gint _tmp9__length1;
	SeahorseSshSecData** secdata_collection;
	gint secdata_collection_length1;
	gint _secdata_collection_size_;
	gint secdata_it;
	SeahorseSshSecData* secdata;
	SeahorseSshPrivateImportOperation* op;
	SeahorseSshPrivateImportOperation* _tmp10_;
	SeahorseSshPrivateImportOperation* _tmp11_;
	SeahorseSshSecData* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceImportPublicAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKeyData* data;
	gchar* filename;
	GCancellable* cancellable;
	gchar* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _Block8Data {
	int _ref_count_;
	SeahorseSshSource* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	GError* err;
	gchar* from;
	gchar* to;
	SeahorseSshKey* key;
	gpointer _async_data_;
};

struct _SeahorseSshSourceAuthorizeAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKey* key;
	gboolean authorize;
	Block8Data* _data8_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThread* thread;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_;
};

static gint SeahorseSshSource_private_offset;
static gpointer seahorse_ssh_source_parent_class = NULL;
static GcrCollectionIface * seahorse_ssh_source_gcr_collection_parent_iface = NULL;
static SeahorsePlaceIface * seahorse_ssh_source_seahorse_place_parent_iface = NULL;

static gboolean seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                                 const gchar* filename);
static void seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self);
static void seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self);
static void ___lambda11_ (SeahorseSshSource* self,
                   GFile* file,
                   GFile* other_file,
                   GFileMonitorEvent event_type);
static gboolean _seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self);
static void ____lambda11__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static guint seahorse_ssh_source_real_get_length (GcrCollection* base);
static GList* seahorse_ssh_source_real_get_objects (GcrCollection* base);
static gboolean seahorse_ssh_source_real_contains (GcrCollection* base,
                                            GObject* object);
static void seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data);
static gboolean seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_);
static void seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                                    const gchar* privfile,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static SeahorseSshKey* seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static void seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data);
static gboolean seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_);
static void seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void seahorse_ssh_source_real_load_data_free (gpointer _data);
static void seahorse_ssh_source_real_load (SeahorsePlace* base,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_);
static gboolean _seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self);
static void seahorse_ssh_source_load_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void seahorse_ssh_source_import_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_);
static void seahorse_ssh_source_import_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void seahorse_ssh_source_import_public_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_);
static void seahorse_ssh_source_authorize_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean _seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self);
static void* __lambda6_ (Block8Data* _data8_);
static void seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                             const gchar* filename);
static gpointer ___lambda6__gthread_func (gpointer self);
static GObject * seahorse_ssh_source_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void seahorse_ssh_source_finalize (GObject * obj);
static GType seahorse_ssh_source_get_type_once (void);
static void _vala_seahorse_ssh_source_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_seahorse_ssh_source_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
seahorse_ssh_source_get_instance_private (SeahorseSshSource* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshSource_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 416 "source.c"
}

static gboolean
seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                        const gchar* filename)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 103 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../ssh/source.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 104 "../ssh/source.vala"
	if (!g_file_test (filename, G_FILE_TEST_IS_REGULAR)) {
#line 105 "../ssh/source.vala"
		result = FALSE;
#line 105 "../ssh/source.vala"
		return result;
#line 435 "source.c"
	}
	{
		gchar* contents = NULL;
		gchar* _tmp0_ = NULL;
		const gchar* _tmp2_;
#line 109 "../ssh/source.vala"
		g_file_get_contents (filename, &_tmp0_, NULL, &_inner_error0_);
#line 109 "../ssh/source.vala"
		_g_free0 (contents);
#line 109 "../ssh/source.vala"
		contents = _tmp0_;
#line 109 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 449 "source.c"
			gboolean _tmp1_ = FALSE;
#line 109 "../ssh/source.vala"
			_g_free0 (contents);
#line 109 "../ssh/source.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 455 "source.c"
				goto __catch0_g_file_error;
			}
#line 109 "../ssh/source.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../ssh/source.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../ssh/source.vala"
			return _tmp1_;
#line 464 "source.c"
		}
#line 112 "../ssh/source.vala"
		_tmp2_ = contents;
#line 112 "../ssh/source.vala"
		result = string_contains (_tmp2_, " PRIVATE KEY-----");
#line 112 "../ssh/source.vala"
		_g_free0 (contents);
#line 112 "../ssh/source.vala"
		return result;
#line 474 "source.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 107 "../ssh/source.vala"
		e = _inner_error0_;
#line 107 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 114 "../ssh/source.vala"
		_tmp3_ = e;
#line 114 "../ssh/source.vala"
		_tmp4_ = _tmp3_->message;
#line 114 "../ssh/source.vala"
		_tmp5_ = g_strdup_printf ("Error reading file '%s' to check for SSH key. %s", filename, _tmp4_);
#line 114 "../ssh/source.vala"
		_tmp6_ = _tmp5_;
#line 114 "../ssh/source.vala"
		g_warning ("source.vala:114: %s", _tmp6_);
#line 114 "../ssh/source.vala"
		_g_free0 (_tmp6_);
#line 107 "../ssh/source.vala"
		_g_error_free0 (e);
#line 502 "source.c"
	}
	__finally0:
#line 107 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 507 "source.c"
		gboolean _tmp7_ = FALSE;
#line 107 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 107 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 107 "../ssh/source.vala"
		return _tmp7_;
#line 515 "source.c"
	}
#line 117 "../ssh/source.vala"
	result = FALSE;
#line 117 "../ssh/source.vala"
	return result;
#line 521 "source.c"
}

static void
seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self)
{
#line 120 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 121 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 122 "../ssh/source.vala"
		g_debug ("source.vala:122: Cancelling scheduled refresh event");
#line 123 "../ssh/source.vala"
		g_source_remove (self->priv->scheduled_refresh_source);
#line 124 "../ssh/source.vala"
		self->priv->scheduled_refresh_source = (guint) 0;
#line 537 "source.c"
	}
}

static gboolean
seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self)
{
	gboolean result;
#line 128 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../ssh/source.vala"
	g_debug ("source.vala:129: Scheduled refresh event ocurring now");
#line 130 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (self);
#line 131 "../ssh/source.vala"
	seahorse_place_load ((SeahorsePlace*) self, NULL, NULL, NULL);
#line 132 "../ssh/source.vala"
	result = FALSE;
#line 132 "../ssh/source.vala"
	return result;
#line 557 "source.c"
}

static gboolean
seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self)
{
	gboolean result;
#line 135 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../ssh/source.vala"
	g_debug ("source.vala:136: Dummy refresh event occurring now");
#line 137 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 138 "../ssh/source.vala"
	result = FALSE;
#line 138 "../ssh/source.vala"
	return result;
#line 574 "source.c"
}

static gboolean
_seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_refresh ((SeahorseSshSource*) self);
#line 169 "../ssh/source.vala"
	return result;
#line 584 "source.c"
}

static void
___lambda11_ (SeahorseSshSource* self,
              GFile* file,
              GFile* other_file,
              GFileMonitorEvent event_type)
{
	gboolean _tmp0_ = FALSE;
	gchar* path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 148 "../ssh/source.vala"
	g_return_if_fail (file != NULL);
#line 149 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 149 "../ssh/source.vala"
		_tmp0_ = TRUE;
#line 607 "source.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 150 "../ssh/source.vala"
		if (event_type != G_FILE_MONITOR_EVENT_CHANGED) {
#line 151 "../ssh/source.vala"
			_tmp3_ = event_type != G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT;
#line 616 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp3_ = FALSE;
#line 620 "source.c"
		}
#line 150 "../ssh/source.vala"
		if (_tmp3_) {
#line 152 "../ssh/source.vala"
			_tmp2_ = event_type != G_FILE_MONITOR_EVENT_DELETED;
#line 626 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp2_ = FALSE;
#line 630 "source.c"
		}
#line 150 "../ssh/source.vala"
		if (_tmp2_) {
#line 153 "../ssh/source.vala"
			_tmp1_ = event_type != G_FILE_MONITOR_EVENT_CREATED;
#line 636 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp1_ = FALSE;
#line 640 "source.c"
		}
#line 150 "../ssh/source.vala"
		_tmp0_ = _tmp1_;
#line 644 "source.c"
	}
#line 149 "../ssh/source.vala"
	if (_tmp0_) {
#line 154 "../ssh/source.vala"
		return;
#line 650 "source.c"
	}
#line 156 "../ssh/source.vala"
	_tmp4_ = g_file_get_path (file);
#line 156 "../ssh/source.vala"
	path = _tmp4_;
#line 157 "../ssh/source.vala"
	_tmp5_ = path;
#line 157 "../ssh/source.vala"
	if (_tmp5_ == NULL) {
#line 158 "../ssh/source.vala"
		_g_free0 (path);
#line 158 "../ssh/source.vala"
		return;
#line 664 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (event_type != G_FILE_MONITOR_EVENT_DELETED) {
#line 668 "source.c"
		const gchar* _tmp10_;
#line 162 "../ssh/source.vala"
		_tmp10_ = path;
#line 162 "../ssh/source.vala"
		_tmp9_ = !g_str_has_suffix (_tmp10_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE);
#line 674 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp9_ = FALSE;
#line 678 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp9_) {
#line 682 "source.c"
		const gchar* _tmp11_;
#line 163 "../ssh/source.vala"
		_tmp11_ = path;
#line 163 "../ssh/source.vala"
		_tmp8_ = !g_str_has_suffix (_tmp11_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE);
#line 688 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp8_ = FALSE;
#line 692 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp8_) {
#line 696 "source.c"
		const gchar* _tmp12_;
#line 164 "../ssh/source.vala"
		_tmp12_ = path;
#line 164 "../ssh/source.vala"
		_tmp7_ = !g_str_has_suffix (_tmp12_, ".pub");
#line 702 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp7_ = FALSE;
#line 706 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp7_) {
#line 710 "source.c"
		const gchar* _tmp13_;
#line 165 "../ssh/source.vala"
		_tmp13_ = path;
#line 165 "../ssh/source.vala"
		_tmp6_ = !seahorse_ssh_sec_data_contains_private_key (_tmp13_);
#line 716 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp6_ = FALSE;
#line 720 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp6_) {
#line 166 "../ssh/source.vala"
		_g_free0 (path);
#line 166 "../ssh/source.vala"
		return;
#line 728 "source.c"
	}
#line 168 "../ssh/source.vala"
	g_debug ("source.vala:168: Scheduling refresh event due to file changes");
#line 169 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_refresh_gsource_func, g_object_ref (self), g_object_unref);
#line 148 "../ssh/source.vala"
	_g_free0 (path);
#line 736 "source.c"
}

static void
____lambda11__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 148 "../ssh/source.vala"
	___lambda11_ ((SeahorseSshSource*) self, file, other_file, event_type);
#line 748 "source.c"
}

static void
seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self)
{
	GFile* dot_ssh_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 141 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 142 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 142 "../ssh/source.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 142 "../ssh/source.vala"
	dot_ssh_dir = _tmp1_;
#line 143 "../ssh/source.vala"
	_tmp2_ = dot_ssh_dir;
#line 143 "../ssh/source.vala"
	if (_tmp2_ == NULL) {
#line 144 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 144 "../ssh/source.vala"
		return;
#line 775 "source.c"
	}
	{
		GFileMonitor* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileMonitor* _tmp5_;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 147 "../ssh/source.vala"
		_tmp4_ = dot_ssh_dir;
#line 147 "../ssh/source.vala"
		_tmp5_ = g_file_monitor_directory (_tmp4_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 147 "../ssh/source.vala"
		_tmp3_ = _tmp5_;
#line 147 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 791 "source.c"
			goto __catch0_g_error;
		}
#line 147 "../ssh/source.vala"
		_tmp6_ = _tmp3_;
#line 147 "../ssh/source.vala"
		_tmp3_ = NULL;
#line 147 "../ssh/source.vala"
		_g_object_unref0 (self->priv->monitor_handle);
#line 147 "../ssh/source.vala"
		self->priv->monitor_handle = _tmp6_;
#line 148 "../ssh/source.vala"
		_tmp7_ = self->priv->monitor_handle;
#line 148 "../ssh/source.vala"
		g_signal_connect_object (_tmp7_, "changed", (GCallback) ____lambda11__g_file_monitor_changed, self, 0);
#line 146 "../ssh/source.vala"
		_g_object_unref0 (_tmp3_);
#line 808 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 146 "../ssh/source.vala"
		e = _inner_error0_;
#line 146 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 172 "../ssh/source.vala"
		_tmp8_ = self->priv->ssh_homedir;
#line 172 "../ssh/source.vala"
		_tmp9_ = e;
#line 172 "../ssh/source.vala"
		_tmp10_ = _tmp9_->message;
#line 172 "../ssh/source.vala"
		g_warning ("source.vala:172: couldn't monitor ssh directory: %s: %s", _tmp8_, _tmp10_);
#line 146 "../ssh/source.vala"
		_g_error_free0 (e);
#line 831 "source.c"
	}
	__finally0:
#line 146 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 146 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 146 "../ssh/source.vala"
		return;
#line 844 "source.c"
	}
#line 141 "../ssh/source.vala"
	_g_object_unref0 (dot_ssh_dir);
#line 848 "source.c"
}

static guint
seahorse_ssh_source_real_get_length (GcrCollection* base)
{
	SeahorseSshSource * self;
	GListStore* _tmp0_;
	guint result;
#line 176 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 177 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 177 "../ssh/source.vala"
	result = g_list_model_get_n_items ((GListModel*) _tmp0_);
#line 177 "../ssh/source.vala"
	return result;
#line 865 "source.c"
}

static GList*
seahorse_ssh_source_real_get_objects (GcrCollection* base)
{
	SeahorseSshSource * self;
	GList* objects = NULL;
	GList* result;
#line 180 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 181 "../ssh/source.vala"
	objects = NULL;
#line 878 "source.c"
	{
		guint i = 0U;
#line 182 "../ssh/source.vala"
		i = (guint) 0;
#line 883 "source.c"
		{
			gboolean _tmp0_ = FALSE;
#line 182 "../ssh/source.vala"
			_tmp0_ = TRUE;
#line 182 "../ssh/source.vala"
			while (TRUE) {
#line 890 "source.c"
				GListStore* _tmp2_;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				GObject* _tmp5_;
#line 182 "../ssh/source.vala"
				if (!_tmp0_) {
#line 897 "source.c"
					guint _tmp1_;
#line 182 "../ssh/source.vala"
					_tmp1_ = i;
#line 182 "../ssh/source.vala"
					i = _tmp1_ + 1;
#line 903 "source.c"
				}
#line 182 "../ssh/source.vala"
				_tmp0_ = FALSE;
#line 182 "../ssh/source.vala"
				_tmp2_ = self->priv->keys;
#line 182 "../ssh/source.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 182 "../ssh/source.vala"
					break;
#line 913 "source.c"
				}
#line 183 "../ssh/source.vala"
				_tmp3_ = self->priv->keys;
#line 183 "../ssh/source.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, i);
#line 183 "../ssh/source.vala"
				_tmp5_ = _tmp4_;
#line 183 "../ssh/source.vala"
				objects = g_list_append (objects, _tmp5_);
#line 183 "../ssh/source.vala"
				_g_object_unref0 (_tmp5_);
#line 925 "source.c"
			}
		}
	}
#line 184 "../ssh/source.vala"
	result = objects;
#line 184 "../ssh/source.vala"
	return result;
#line 933 "source.c"
}

static gboolean
seahorse_ssh_source_real_contains (GcrCollection* base,
                                   GObject* object)
{
	SeahorseSshSource * self;
	GListStore* _tmp0_;
	gboolean result;
#line 187 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 187 "../ssh/source.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 188 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 188 "../ssh/source.vala"
	result = g_list_store_find (_tmp0_, object, NULL);
#line 188 "../ssh/source.vala"
	return result;
#line 953 "source.c"
}

void
seahorse_ssh_source_remove_object (SeahorseSshSource* self,
                                   GObject* object)
{
	guint pos = 0U;
	GListStore* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
#line 191 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 191 "../ssh/source.vala"
	g_return_if_fail (object != NULL);
#line 193 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 193 "../ssh/source.vala"
	_tmp2_ = g_list_store_find (_tmp0_, object, &_tmp1_);
#line 193 "../ssh/source.vala"
	pos = _tmp1_;
#line 193 "../ssh/source.vala"
	if (_tmp2_) {
#line 976 "source.c"
		GListStore* _tmp3_;
#line 194 "../ssh/source.vala"
		_tmp3_ = self->priv->keys;
#line 194 "../ssh/source.vala"
		g_list_store_remove (_tmp3_, pos);
#line 195 "../ssh/source.vala"
		g_signal_emit_by_name ((GcrCollection*) self, "removed", object);
#line 984 "source.c"
	}
}

gchar*
seahorse_ssh_source_authorized_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 199 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 200 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE, NULL);
#line 200 "../ssh/source.vala"
	result = _tmp1_;
#line 200 "../ssh/source.vala"
	return result;
#line 1004 "source.c"
}

gchar*
seahorse_ssh_source_other_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 203 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 204 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE, NULL);
#line 204 "../ssh/source.vala"
	result = _tmp1_;
#line 204 "../ssh/source.vala"
	return result;
#line 1023 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAddKeyFromFilenameData, _data_);
#line 1039 "source.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../ssh/source.vala"
	return self ? g_object_ref (self) : NULL;
#line 1047 "source.c"
}

void
seahorse_ssh_source_add_key_from_filename (SeahorseSshSource* self,
                                           const gchar* privfile,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAddKeyFromFilenameData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_add_key_from_filename_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1079 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_filename_finish (SeahorseSshSource* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1095 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1103 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 219 "../ssh/source.vala"
	_data_ = _user_data_;
#line 219 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 219 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 219 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1120 "source.c"
}

static gboolean
seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_)
{
#line 207 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 207 "../ssh/source.vala"
		case 0:
#line 1130 "source.c"
		goto _state_0;
#line 207 "../ssh/source.vala"
		case 1:
#line 1134 "source.c"
		goto _state_1;
		default:
#line 207 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1139 "source.c"
	}
	_state_0:
#line 208 "../ssh/source.vala"
	if (_data_->privfile == NULL) {
#line 209 "../ssh/source.vala"
		_data_->result = NULL;
#line 209 "../ssh/source.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 209 "../ssh/source.vala"
		if (_data_->_state_ != 0) {
#line 209 "../ssh/source.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 209 "../ssh/source.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1154 "source.c"
			}
		}
#line 209 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 209 "../ssh/source.vala"
		return FALSE;
#line 1161 "source.c"
	}
	{
#line 212 "../ssh/source.vala"
		_data_->i = (guint) 0;
#line 1166 "source.c"
		{
#line 212 "../ssh/source.vala"
			_data_->_tmp0_ = TRUE;
#line 212 "../ssh/source.vala"
			while (TRUE) {
#line 212 "../ssh/source.vala"
				if (!_data_->_tmp0_) {
#line 212 "../ssh/source.vala"
					_data_->_tmp1_ = _data_->i;
#line 212 "../ssh/source.vala"
					_data_->i = _data_->_tmp1_ + 1;
#line 1178 "source.c"
				}
#line 212 "../ssh/source.vala"
				_data_->_tmp0_ = FALSE;
#line 212 "../ssh/source.vala"
				_data_->_tmp2_ = _data_->self->priv->keys;
#line 212 "../ssh/source.vala"
				if (!(_data_->i < g_list_model_get_n_items ((GListModel*) _data_->_tmp2_))) {
#line 212 "../ssh/source.vala"
					break;
#line 1188 "source.c"
				}
#line 213 "../ssh/source.vala"
				_data_->_tmp3_ = _data_->self->priv->keys;
#line 213 "../ssh/source.vala"
				_data_->_tmp4_ = g_list_model_get_item ((GListModel*) _data_->_tmp3_, _data_->i);
#line 213 "../ssh/source.vala"
				_data_->key = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 214 "../ssh/source.vala"
				_data_->_tmp5_ = _data_->key;
#line 214 "../ssh/source.vala"
				_data_->_tmp6_ = seahorse_ssh_key_get_key_data (_data_->_tmp5_);
#line 214 "../ssh/source.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 214 "../ssh/source.vala"
				_data_->_tmp8_ = seahorse_ssh_key_data_get_privfile (_data_->_tmp7_);
#line 214 "../ssh/source.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 214 "../ssh/source.vala"
				if (g_strcmp0 (_data_->_tmp9_, _data_->privfile) == 0) {
#line 215 "../ssh/source.vala"
					_data_->result = _data_->key;
#line 215 "../ssh/source.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 215 "../ssh/source.vala"
					if (_data_->_state_ != 0) {
#line 215 "../ssh/source.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 215 "../ssh/source.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1218 "source.c"
						}
					}
#line 215 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 215 "../ssh/source.vala"
					return FALSE;
#line 1225 "source.c"
				}
#line 212 "../ssh/source.vala"
				_g_object_unref0 (_data_->key);
#line 1229 "source.c"
			}
		}
	}
#line 219 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 219 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->privfile, seahorse_ssh_source_add_key_from_filename_ready, _data_);
#line 219 "../ssh/source.vala"
	return FALSE;
#line 1239 "source.c"
	_state_1:
#line 219 "../ssh/source.vala"
	_data_->_tmp11_ = seahorse_ssh_source_load_key_for_private_file_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 219 "../ssh/source.vala"
	_data_->_tmp10_ = _data_->_tmp11_;
#line 219 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 219 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 219 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 219 "../ssh/source.vala"
		return FALSE;
#line 1253 "source.c"
	}
#line 219 "../ssh/source.vala"
	_data_->_tmp12_ = _data_->_tmp10_;
#line 219 "../ssh/source.vala"
	_data_->_tmp10_ = NULL;
#line 219 "../ssh/source.vala"
	_data_->result = _data_->_tmp12_;
#line 219 "../ssh/source.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 219 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 219 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 219 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 219 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1271 "source.c"
		}
	}
#line 219 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 219 "../ssh/source.vala"
	return FALSE;
#line 1278 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadKeyForPrivateFileData, _data_);
#line 1294 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                               const gchar* privfile,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (privfile != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadKeyForPrivateFileData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_load_key_for_private_file_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1328 "source.c"
}

static SeahorseSshKey*
seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1344 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1352 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 232 "../ssh/source.vala"
	_data_ = _user_data_;
#line 232 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 232 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 232 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1369 "source.c"
}

static gboolean
seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_)
{
#line 223 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 223 "../ssh/source.vala"
		case 0:
#line 1379 "source.c"
		goto _state_0;
#line 223 "../ssh/source.vala"
		case 1:
#line 1383 "source.c"
		goto _state_1;
		default:
#line 223 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1388 "source.c"
	}
	_state_0:
#line 224 "../ssh/source.vala"
	_data_->_tmp0_ = g_strconcat (_data_->privfile, ".pub", NULL);
#line 224 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp0_;
#line 225 "../ssh/source.vala"
	_data_->key = NULL;
#line 228 "../ssh/source.vala"
	if (g_file_test (_data_->privfile, G_FILE_TEST_EXISTS)) {
#line 229 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->pubfile;
#line 229 "../ssh/source.vala"
		_data_->_tmp2_ = g_file_test (_data_->_tmp3_, G_FILE_TEST_EXISTS);
#line 1403 "source.c"
	} else {
#line 228 "../ssh/source.vala"
		_data_->_tmp2_ = FALSE;
#line 1407 "source.c"
	}
#line 228 "../ssh/source.vala"
	if (_data_->_tmp2_) {
#line 230 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_check_file_for_ssh (_data_->self, _data_->privfile);
#line 1413 "source.c"
	} else {
#line 228 "../ssh/source.vala"
		_data_->_tmp1_ = FALSE;
#line 1417 "source.c"
	}
#line 228 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 1421 "source.c"
		{
#line 232 "../ssh/source.vala"
			_data_->_tmp4_ = _data_->pubfile;
#line 232 "../ssh/source.vala"
			memset (&_data_->_tmp5_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 232 "../ssh/source.vala"
			_data_->_state_ = 1;
#line 232 "../ssh/source.vala"
			seahorse_ssh_key_parse_file (_data_->_tmp4_, NULL, seahorse_ssh_source_load_key_for_private_file_ready, _data_);
#line 232 "../ssh/source.vala"
			return FALSE;
#line 1433 "source.c"
			_state_1:
#line 232 "../ssh/source.vala"
			seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp5_, &_data_->_inner_error0_);
#line 232 "../ssh/source.vala"
			_data_->_result_ = _data_->_tmp5_;
#line 232 "../ssh/source.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1441 "source.c"
				goto __catch0_g_error;
			}
#line 233 "../ssh/source.vala"
			_data_->_tmp6_ = _data_->_result_;
#line 233 "../ssh/source.vala"
			_data_->_tmp7_ = _data_->_tmp6_.public_keys;
#line 233 "../ssh/source.vala"
			_data_->_tmp7__length1 = _data_->_tmp6_.public_keys_length1;
#line 1450 "source.c"
			{
#line 233 "../ssh/source.vala"
				_data_->keydata_collection_length1 = 0;
#line 233 "../ssh/source.vala"
				_data_->_keydata_collection_size_ = 0;
#line 233 "../ssh/source.vala"
				_data_->keydata_collection = _data_->_tmp7_;
#line 233 "../ssh/source.vala"
				_data_->keydata_collection_length1 = _data_->_tmp7__length1;
#line 233 "../ssh/source.vala"
				for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 233 "../ssh/source.vala"
					_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 1464 "source.c"
					{
#line 234 "../ssh/source.vala"
						_data_->_tmp8_ = _data_->keydata;
#line 234 "../ssh/source.vala"
						_data_->_tmp9_ = _data_->pubfile;
#line 234 "../ssh/source.vala"
						_data_->_tmp10_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp8_, _data_->_tmp9_, FALSE, FALSE, _data_->privfile);
#line 234 "../ssh/source.vala"
						_g_object_unref0 (_data_->key);
#line 234 "../ssh/source.vala"
						_data_->key = _data_->_tmp10_;
#line 1476 "source.c"
					}
				}
			}
#line 231 "../ssh/source.vala"
			seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 1482 "source.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 231 "../ssh/source.vala"
			_data_->e = _data_->_inner_error0_;
#line 231 "../ssh/source.vala"
			_data_->_inner_error0_ = NULL;
#line 237 "../ssh/source.vala"
			_data_->_tmp11_ = _data_->pubfile;
#line 237 "../ssh/source.vala"
			_data_->_tmp12_ = _data_->e;
#line 237 "../ssh/source.vala"
			_data_->_tmp13_ = _data_->_tmp12_->message;
#line 237 "../ssh/source.vala"
			_data_->_tmp14_ = g_strdup_printf ("Couldn't read SSH file: %s (%s)", _data_->_tmp11_, _data_->_tmp13_);
#line 237 "../ssh/source.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 237 "../ssh/source.vala"
			_data_->_tmp16_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _data_->_tmp15_);
#line 237 "../ssh/source.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 237 "../ssh/source.vala"
			_g_free0 (_data_->_tmp15_);
#line 237 "../ssh/source.vala"
			_data_->_inner_error0_ = _data_->_tmp17_;
#line 237 "../ssh/source.vala"
			_g_error_free0 (_data_->e);
#line 1511 "source.c"
			goto __finally0;
		}
		__finally0:
#line 231 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 231 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 231 "../ssh/source.vala"
			_g_object_unref0 (_data_->key);
#line 231 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 231 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 231 "../ssh/source.vala"
			return FALSE;
#line 1527 "source.c"
		}
	}
#line 241 "../ssh/source.vala"
	_data_->result = _data_->key;
#line 241 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 241 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 241 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 241 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 241 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1542 "source.c"
		}
	}
#line 241 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 241 "../ssh/source.vala"
	return FALSE;
#line 1549 "source.c"
}

gchar*
seahorse_ssh_source_export_private (SeahorseSshSource* self,
                                    SeahorseSshKey* key,
                                    GError** error)
{
	SeahorseSshKeyData* keydata = NULL;
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	SeahorseSshKeyData* _tmp3_;
	SeahorseSshKeyData* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* results = NULL;
	gboolean _tmp8_ = FALSE;
	SeahorseSshKeyData* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 244 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../ssh/source.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 245 "../ssh/source.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (key);
#line 245 "../ssh/source.vala"
	_tmp1_ = _tmp0_;
#line 245 "../ssh/source.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 245 "../ssh/source.vala"
	keydata = _tmp2_;
#line 246 "../ssh/source.vala"
	_tmp3_ = keydata;
#line 246 "../ssh/source.vala"
	if (_tmp3_ == NULL) {
#line 247 "../ssh/source.vala"
		result = NULL;
#line 247 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 247 "../ssh/source.vala"
		return result;
#line 1596 "source.c"
	}
#line 249 "../ssh/source.vala"
	_tmp4_ = keydata;
#line 249 "../ssh/source.vala"
	_tmp5_ = seahorse_ssh_key_data_get_privfile (_tmp4_);
#line 249 "../ssh/source.vala"
	_tmp6_ = _tmp5_;
#line 249 "../ssh/source.vala"
	if (_tmp6_ == NULL) {
#line 1606 "source.c"
		GError* _tmp7_;
#line 250 "../ssh/source.vala"
		_tmp7_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _ ("No private key file is available for this key."));
#line 250 "../ssh/source.vala"
		_inner_error0_ = _tmp7_;
#line 250 "../ssh/source.vala"
		g_propagate_error (error, _inner_error0_);
#line 250 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 250 "../ssh/source.vala"
		return NULL;
#line 1618 "source.c"
	}
#line 254 "../ssh/source.vala"
	_tmp9_ = keydata;
#line 254 "../ssh/source.vala"
	_tmp10_ = seahorse_ssh_key_data_get_privfile (_tmp9_);
#line 254 "../ssh/source.vala"
	_tmp11_ = _tmp10_;
#line 254 "../ssh/source.vala"
	_tmp13_ = g_file_get_contents (_tmp11_, &_tmp12_, NULL, &_inner_error0_);
#line 254 "../ssh/source.vala"
	_g_free0 (results);
#line 254 "../ssh/source.vala"
	results = _tmp12_;
#line 254 "../ssh/source.vala"
	_tmp8_ = _tmp13_;
#line 254 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../ssh/source.vala"
		g_propagate_error (error, _inner_error0_);
#line 254 "../ssh/source.vala"
		_g_free0 (results);
#line 254 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 254 "../ssh/source.vala"
		return NULL;
#line 1644 "source.c"
	}
#line 254 "../ssh/source.vala"
	if (!_tmp8_) {
#line 255 "../ssh/source.vala"
		result = NULL;
#line 255 "../ssh/source.vala"
		_g_free0 (results);
#line 255 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 255 "../ssh/source.vala"
		return result;
#line 1656 "source.c"
	}
#line 257 "../ssh/source.vala"
	result = results;
#line 257 "../ssh/source.vala"
	_g_object_unref0 (keydata);
#line 257 "../ssh/source.vala"
	return result;
#line 1664 "source.c"
}

static void
seahorse_ssh_source_real_load_data_free (gpointer _data)
{
	SeahorseSshSourceLoadData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadData, _data_);
#line 1678 "source.c"
}

static void
seahorse_ssh_source_real_load (SeahorsePlace* base,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	SeahorseSshSource * self;
	SeahorseSshSourceLoadData* _data_;
	SeahorseSshSource* _tmp0_;
	GCancellable* _tmp1_;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_real_load_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_real_load_co (_data_);
#line 1711 "source.c"
}

static gboolean
seahorse_ssh_source_load_finish (SeahorsePlace* base,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	gboolean result;
	SeahorseSshSourceLoadData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 1725 "source.c"
		gboolean _tmp0_ = FALSE;
#line 26 "../ssh/source.vala"
		return _tmp0_;
#line 1729 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	return result;
#line 1735 "source.c"
}

/**
     * Loads the keys from this Source's directory.
     *
     * @param cancellable Use this to cancel the operation.
     */
static gboolean
_seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_dummy ((SeahorseSshSource*) self);
#line 268 "../ssh/source.vala"
	return result;
#line 1750 "source.c"
}

static void
seahorse_ssh_source_load_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	SeahorseSshSourceLoadData* _data_;
#line 284 "../ssh/source.vala"
	_data_ = _user_data_;
#line 284 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 284 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 284 "../ssh/source.vala"
	seahorse_ssh_source_real_load_co (_data_);
#line 1767 "source.c"
}

static gboolean
seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_)
{
#line 265 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 265 "../ssh/source.vala"
		case 0:
#line 1777 "source.c"
		goto _state_0;
#line 265 "../ssh/source.vala"
		case 1:
#line 1781 "source.c"
		goto _state_1;
#line 265 "../ssh/source.vala"
		case 2:
#line 1785 "source.c"
		goto _state_2;
		default:
#line 265 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1790 "source.c"
	}
	_state_0:
#line 267 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (_data_->self);
#line 268 "../ssh/source.vala"
	_data_->self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_dummy_gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 269 "../ssh/source.vala"
	g_debug ("source.vala:269: scheduled a dummy refresh");
#line 272 "../ssh/source.vala"
	_data_->_tmp0_ = _data_->self->priv->ssh_homedir;
#line 272 "../ssh/source.vala"
	_data_->_tmp1_ = g_dir_open (_data_->_tmp0_, (guint) 0, &_data_->_inner_error0_);
#line 272 "../ssh/source.vala"
	_data_->dir = _data_->_tmp1_;
#line 272 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 272 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 272 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 272 "../ssh/source.vala"
		return FALSE;
#line 1813 "source.c"
	}
#line 275 "../ssh/source.vala"
	_data_->filename = NULL;
#line 276 "../ssh/source.vala"
	while (TRUE) {
#line 276 "../ssh/source.vala"
		_data_->_tmp2_ = _data_->dir;
#line 276 "../ssh/source.vala"
		_data_->_tmp3_ = g_dir_read_name (_data_->_tmp2_);
#line 276 "../ssh/source.vala"
		_data_->_tmp4_ = g_strdup (_data_->_tmp3_);
#line 276 "../ssh/source.vala"
		_g_free0 (_data_->filename);
#line 276 "../ssh/source.vala"
		_data_->filename = _data_->_tmp4_;
#line 276 "../ssh/source.vala"
		_data_->_tmp5_ = _data_->filename;
#line 276 "../ssh/source.vala"
		if (!(_data_->_tmp5_ != NULL)) {
#line 276 "../ssh/source.vala"
			break;
#line 1835 "source.c"
		}
#line 277 "../ssh/source.vala"
		_data_->_tmp6_ = _data_->self->priv->ssh_homedir;
#line 277 "../ssh/source.vala"
		_data_->_tmp7_ = _data_->filename;
#line 277 "../ssh/source.vala"
		_data_->_tmp8_ = g_build_filename (_data_->_tmp6_, _data_->_tmp7_, NULL);
#line 277 "../ssh/source.vala"
		_data_->privfile = _data_->_tmp8_;
#line 278 "../ssh/source.vala"
		_data_->_tmp9_ = _data_->privfile;
#line 278 "../ssh/source.vala"
		seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->_tmp9_, NULL, NULL);
#line 276 "../ssh/source.vala"
		_g_free0 (_data_->privfile);
#line 1851 "source.c"
	}
#line 282 "../ssh/source.vala"
	_data_->_tmp10_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 282 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp10_;
#line 283 "../ssh/source.vala"
	_data_->_tmp11_ = _data_->pubfile;
#line 283 "../ssh/source.vala"
	if (g_file_test (_data_->_tmp11_, G_FILE_TEST_IS_REGULAR)) {
#line 284 "../ssh/source.vala"
		_data_->_tmp12_ = _data_->pubfile;
#line 284 "../ssh/source.vala"
		memset (&_data_->_tmp13_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 284 "../ssh/source.vala"
		_data_->_state_ = 1;
#line 284 "../ssh/source.vala"
		seahorse_ssh_key_parse_file (_data_->_tmp12_, NULL, seahorse_ssh_source_load_ready, _data_);
#line 284 "../ssh/source.vala"
		return FALSE;
#line 1871 "source.c"
		_state_1:
#line 284 "../ssh/source.vala"
		seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp13_, &_data_->_inner_error0_);
#line 284 "../ssh/source.vala"
		_data_->_result_ = _data_->_tmp13_;
#line 284 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 284 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 284 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 284 "../ssh/source.vala"
			_g_free0 (_data_->filename);
#line 284 "../ssh/source.vala"
			_g_dir_close0 (_data_->dir);
#line 284 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 284 "../ssh/source.vala"
			return FALSE;
#line 1891 "source.c"
		}
#line 285 "../ssh/source.vala"
		_data_->_tmp14_ = _data_->_result_;
#line 285 "../ssh/source.vala"
		_data_->_tmp15_ = _data_->_tmp14_.public_keys;
#line 285 "../ssh/source.vala"
		_data_->_tmp15__length1 = _data_->_tmp14_.public_keys_length1;
#line 1899 "source.c"
		{
#line 285 "../ssh/source.vala"
			_data_->keydata_collection_length1 = 0;
#line 285 "../ssh/source.vala"
			_data_->_keydata_collection_size_ = 0;
#line 285 "../ssh/source.vala"
			_data_->keydata_collection = _data_->_tmp15_;
#line 285 "../ssh/source.vala"
			_data_->keydata_collection_length1 = _data_->_tmp15__length1;
#line 285 "../ssh/source.vala"
			for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 285 "../ssh/source.vala"
				_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 1913 "source.c"
				{
#line 286 "../ssh/source.vala"
					_data_->_tmp16_ = _data_->keydata;
#line 286 "../ssh/source.vala"
					_data_->_tmp17_ = _data_->pubfile;
#line 286 "../ssh/source.vala"
					_data_->_tmp18_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp16_, _data_->_tmp17_, TRUE, TRUE, NULL);
#line 286 "../ssh/source.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 286 "../ssh/source.vala"
					_g_object_unref0 (_data_->_tmp19_);
#line 1925 "source.c"
				}
			}
		}
#line 283 "../ssh/source.vala"
		seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 1931 "source.c"
	}
#line 291 "../ssh/source.vala"
	_data_->_tmp20_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 291 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 291 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp20_;
#line 292 "../ssh/source.vala"
	_data_->_tmp21_ = _data_->pubfile;
#line 292 "../ssh/source.vala"
	if (g_file_test (_data_->_tmp21_, G_FILE_TEST_IS_REGULAR)) {
#line 293 "../ssh/source.vala"
		_data_->_tmp22_ = _data_->pubfile;
#line 293 "../ssh/source.vala"
		memset (&_data_->_tmp23_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 293 "../ssh/source.vala"
		_data_->_state_ = 2;
#line 293 "../ssh/source.vala"
		seahorse_ssh_key_parse_file (_data_->_tmp22_, NULL, seahorse_ssh_source_load_ready, _data_);
#line 293 "../ssh/source.vala"
		return FALSE;
#line 1953 "source.c"
		_state_2:
#line 293 "../ssh/source.vala"
		seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp23_, &_data_->_inner_error0_);
#line 293 "../ssh/source.vala"
		_data_->_vala1__result_ = _data_->_tmp23_;
#line 293 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 293 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 293 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 293 "../ssh/source.vala"
			_g_free0 (_data_->filename);
#line 293 "../ssh/source.vala"
			_g_dir_close0 (_data_->dir);
#line 293 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 293 "../ssh/source.vala"
			return FALSE;
#line 1973 "source.c"
		}
#line 294 "../ssh/source.vala"
		_data_->_tmp24_ = _data_->_vala1__result_;
#line 294 "../ssh/source.vala"
		_data_->_tmp25_ = _data_->_tmp24_.public_keys;
#line 294 "../ssh/source.vala"
		_data_->_tmp25__length1 = _data_->_tmp24_.public_keys_length1;
#line 1981 "source.c"
		{
#line 294 "../ssh/source.vala"
			_data_->_vala1_keydata_collection_length1 = 0;
#line 294 "../ssh/source.vala"
			_data_->__vala1_keydata_collection_size_ = 0;
#line 294 "../ssh/source.vala"
			_data_->_vala1_keydata_collection = _data_->_tmp25_;
#line 294 "../ssh/source.vala"
			_data_->_vala1_keydata_collection_length1 = _data_->_tmp25__length1;
#line 294 "../ssh/source.vala"
			for (_data_->_vala1_keydata_it = 0; _data_->_vala1_keydata_it < _data_->_vala1_keydata_collection_length1; _data_->_vala1_keydata_it = _data_->_vala1_keydata_it + 1) {
#line 294 "../ssh/source.vala"
				_data_->_vala1_keydata = _data_->_vala1_keydata_collection[_data_->_vala1_keydata_it];
#line 1995 "source.c"
				{
#line 295 "../ssh/source.vala"
					_data_->_tmp26_ = _data_->_vala1_keydata;
#line 295 "../ssh/source.vala"
					_data_->_tmp27_ = _data_->pubfile;
#line 295 "../ssh/source.vala"
					_data_->_tmp28_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp26_, _data_->_tmp27_, TRUE, FALSE, NULL);
#line 295 "../ssh/source.vala"
					_data_->_tmp29_ = _data_->_tmp28_;
#line 295 "../ssh/source.vala"
					_g_object_unref0 (_data_->_tmp29_);
#line 2007 "source.c"
				}
			}
		}
#line 292 "../ssh/source.vala"
		seahorse_ssh_key_key_parse_result_destroy (&_data_->_vala1__result_);
#line 2013 "source.c"
	}
#line 299 "../ssh/source.vala"
	_data_->result = TRUE;
#line 299 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 299 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 299 "../ssh/source.vala"
	_g_dir_close0 (_data_->dir);
#line 299 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 299 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 299 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 299 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2031 "source.c"
		}
	}
#line 299 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 299 "../ssh/source.vala"
	return FALSE;
#line 2038 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_parsed_data (SeahorseSshSource* src,
                                              SeahorseSshKeyData* keydata,
                                              const gchar* pubfile,
                                              gboolean partial,
                                              gboolean authorized,
                                              const gchar* privfile)
{
	gboolean _tmp0_ = FALSE;
	SeahorseSshKey* prev = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SeahorseSshKey* _tmp3_;
	SeahorseSshKey* _tmp4_;
	SeahorseSshKey* _tmp6_;
	SeahorseSshKey* key = NULL;
	SeahorseSshKey* _tmp7_;
	GListStore* _tmp8_;
	SeahorseSshKey* _tmp9_;
	SeahorseSshKey* _tmp10_;
	SeahorseSshKey* result;
#line 302 "../ssh/source.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 302 "../ssh/source.vala"
	g_return_val_if_fail (pubfile != NULL, NULL);
#line 308 "../ssh/source.vala"
	if (keydata != NULL) {
#line 308 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_data_is_valid (keydata);
#line 2070 "source.c"
	} else {
#line 308 "../ssh/source.vala"
		_tmp0_ = FALSE;
#line 2074 "source.c"
	}
#line 308 "../ssh/source.vala"
	g_return_val_if_fail (_tmp0_, NULL);
#line 310 "../ssh/source.vala"
	seahorse_ssh_key_data_set_pubfile (keydata, pubfile);
#line 311 "../ssh/source.vala"
	seahorse_ssh_key_data_set_partial (keydata, partial);
#line 312 "../ssh/source.vala"
	seahorse_ssh_key_data_set_authorized (keydata, authorized);
#line 313 "../ssh/source.vala"
	if (privfile != NULL) {
#line 314 "../ssh/source.vala"
		seahorse_ssh_key_data_set_privfile (keydata, privfile);
#line 2088 "source.c"
	}
#line 317 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_key_data_get_fingerprint (keydata);
#line 317 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 317 "../ssh/source.vala"
	_tmp3_ = seahorse_ssh_source_find_key_by_fingerprint (src, _tmp2_);
#line 317 "../ssh/source.vala"
	prev = _tmp3_;
#line 318 "../ssh/source.vala"
	_tmp4_ = prev;
#line 318 "../ssh/source.vala"
	if (_tmp4_ != NULL) {
#line 2102 "source.c"
		SeahorseSshKey* _tmp5_;
#line 319 "../ssh/source.vala"
		_tmp5_ = prev;
#line 319 "../ssh/source.vala"
		seahorse_ssh_key_merge_keydata (_tmp5_, keydata);
#line 2108 "source.c"
	}
#line 322 "../ssh/source.vala"
	_tmp6_ = prev;
#line 322 "../ssh/source.vala"
	if (_tmp6_ != NULL) {
#line 323 "../ssh/source.vala"
		result = prev;
#line 323 "../ssh/source.vala"
		return result;
#line 2118 "source.c"
	}
#line 326 "../ssh/source.vala"
	_tmp7_ = seahorse_ssh_key_new (src, keydata);
#line 326 "../ssh/source.vala"
	key = _tmp7_;
#line 327 "../ssh/source.vala"
	_tmp8_ = src->priv->keys;
#line 327 "../ssh/source.vala"
	_tmp9_ = key;
#line 327 "../ssh/source.vala"
	g_list_store_append (_tmp8_, (GObject*) _tmp9_);
#line 328 "../ssh/source.vala"
	_tmp10_ = key;
#line 328 "../ssh/source.vala"
	g_signal_emit_by_name ((GcrCollection*) src, "added", (GObject*) _tmp10_);
#line 330 "../ssh/source.vala"
	result = key;
#line 330 "../ssh/source.vala"
	_g_object_unref0 (prev);
#line 330 "../ssh/source.vala"
	return result;
#line 2140 "source.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 26 "../ssh/source.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2148 "source.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 26 "../ssh/source.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2156 "source.c"
}

static void
seahorse_ssh_source_import_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	(_data_->result == NULL) ? NULL : (_data_->result = (_g_list_free__g_object_unref0_ (_data_->result), NULL));
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportAsyncData, _data_);
#line 2176 "source.c"
}

void
seahorse_ssh_source_import_async (SeahorseSshSource* self,
                                  GInputStream* input,
                                  GtkWindow* transient_for,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SeahorseSshSourceImportAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	GInputStream* _tmp1_;
	GtkWindow* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (input != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_data_->input = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = _g_object_ref0 (transient_for);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	_data_->transient_for = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_async_co (_data_);
#line 2226 "source.c"
}

GList*
seahorse_ssh_source_import_finish (SeahorseSshSource* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GList* result;
	SeahorseSshSourceImportAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2242 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2250 "source.c"
}

/**
     * Parse an inputstream into a list of keys and import those keys.
     */
static void
seahorse_ssh_source_import_async_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	SeahorseSshSourceImportAsyncData* _data_;
#line 339 "../ssh/source.vala"
	_data_ = _user_data_;
#line 339 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 339 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 339 "../ssh/source.vala"
	seahorse_ssh_source_import_async_co (_data_);
#line 2270 "source.c"
}

static gboolean
seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_)
{
#line 336 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 336 "../ssh/source.vala"
		case 0:
#line 2280 "source.c"
		goto _state_0;
#line 336 "../ssh/source.vala"
		case 1:
#line 2284 "source.c"
		goto _state_1;
#line 336 "../ssh/source.vala"
		case 2:
#line 2288 "source.c"
		goto _state_2;
#line 336 "../ssh/source.vala"
		case 3:
#line 2292 "source.c"
		goto _state_3;
		default:
#line 336 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2297 "source.c"
	}
	_state_0:
#line 339 "../ssh/source.vala"
	memset (&_data_->_tmp0_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 339 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 339 "../ssh/source.vala"
	seahorse_ssh_key_parse (_data_->input, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 339 "../ssh/source.vala"
	return FALSE;
#line 2308 "source.c"
	_state_1:
#line 339 "../ssh/source.vala"
	seahorse_ssh_key_parse_finish (_data_->_res_, &_data_->_tmp0_, &_data_->_inner_error0_);
#line 339 "../ssh/source.vala"
	_data_->_result_ = _data_->_tmp0_;
#line 339 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 339 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 339 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 339 "../ssh/source.vala"
		return FALSE;
#line 2322 "source.c"
	}
#line 341 "../ssh/source.vala"
	_data_->_tmp1_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 341 "../ssh/source.vala"
	_data_->fullpath = _data_->_tmp1_;
#line 342 "../ssh/source.vala"
	_data_->_tmp2_ = _data_->_result_;
#line 342 "../ssh/source.vala"
	_data_->_tmp3_ = _data_->_tmp2_.public_keys;
#line 342 "../ssh/source.vala"
	_data_->_tmp3__length1 = _data_->_tmp2_.public_keys_length1;
#line 2334 "source.c"
	{
#line 342 "../ssh/source.vala"
		_data_->keydata_collection_length1 = 0;
#line 342 "../ssh/source.vala"
		_data_->_keydata_collection_size_ = 0;
#line 342 "../ssh/source.vala"
		_data_->keydata_collection = _data_->_tmp3_;
#line 342 "../ssh/source.vala"
		_data_->keydata_collection_length1 = _data_->_tmp3__length1;
#line 342 "../ssh/source.vala"
		for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 342 "../ssh/source.vala"
			_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 2348 "source.c"
			{
#line 343 "../ssh/source.vala"
				_data_->_tmp4_ = _data_->keydata;
#line 343 "../ssh/source.vala"
				_data_->_tmp5_ = _data_->fullpath;
#line 343 "../ssh/source.vala"
				_data_->_state_ = 2;
#line 343 "../ssh/source.vala"
				seahorse_ssh_source_import_public_async (_data_->self, _data_->_tmp4_, _data_->_tmp5_, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 343 "../ssh/source.vala"
				return FALSE;
#line 2360 "source.c"
				_state_2:
#line 343 "../ssh/source.vala"
				_data_->_tmp6_ = seahorse_ssh_source_import_public_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 343 "../ssh/source.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 343 "../ssh/source.vala"
				_g_free0 (_data_->_tmp7_);
#line 343 "../ssh/source.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 343 "../ssh/source.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 343 "../ssh/source.vala"
					_g_free0 (_data_->fullpath);
#line 343 "../ssh/source.vala"
					seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 343 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 343 "../ssh/source.vala"
					return FALSE;
#line 2380 "source.c"
				}
			}
		}
	}
#line 345 "../ssh/source.vala"
	_data_->_tmp8_ = _data_->_result_;
#line 345 "../ssh/source.vala"
	_data_->_tmp9_ = _data_->_tmp8_.secret_keys;
#line 345 "../ssh/source.vala"
	_data_->_tmp9__length1 = _data_->_tmp8_.secret_keys_length1;
#line 2391 "source.c"
	{
#line 345 "../ssh/source.vala"
		_data_->secdata_collection_length1 = 0;
#line 345 "../ssh/source.vala"
		_data_->_secdata_collection_size_ = 0;
#line 345 "../ssh/source.vala"
		_data_->secdata_collection = _data_->_tmp9_;
#line 345 "../ssh/source.vala"
		_data_->secdata_collection_length1 = _data_->_tmp9__length1;
#line 345 "../ssh/source.vala"
		for (_data_->secdata_it = 0; _data_->secdata_it < _data_->secdata_collection_length1; _data_->secdata_it = _data_->secdata_it + 1) {
#line 345 "../ssh/source.vala"
			_data_->secdata = _data_->secdata_collection[_data_->secdata_it];
#line 2405 "source.c"
			{
#line 346 "../ssh/source.vala"
				_data_->_tmp10_ = seahorse_ssh_private_import_operation_new ();
#line 346 "../ssh/source.vala"
				_data_->op = _data_->_tmp10_;
#line 347 "../ssh/source.vala"
				_data_->_tmp11_ = _data_->op;
#line 347 "../ssh/source.vala"
				_data_->_tmp12_ = _data_->secdata;
#line 347 "../ssh/source.vala"
				_data_->_state_ = 3;
#line 347 "../ssh/source.vala"
				seahorse_ssh_private_import_operation_import_private_async (_data_->_tmp11_, _data_->self, _data_->_tmp12_, NULL, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 347 "../ssh/source.vala"
				return FALSE;
#line 2421 "source.c"
				_state_3:
#line 347 "../ssh/source.vala"
				_data_->_tmp13_ = seahorse_ssh_private_import_operation_import_private_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 347 "../ssh/source.vala"
				_data_->_tmp14_ = _data_->_tmp13_;
#line 347 "../ssh/source.vala"
				_g_free0 (_data_->_tmp14_);
#line 347 "../ssh/source.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 347 "../ssh/source.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 347 "../ssh/source.vala"
					_g_object_unref0 (_data_->op);
#line 347 "../ssh/source.vala"
					_g_free0 (_data_->fullpath);
#line 347 "../ssh/source.vala"
					seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 347 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 347 "../ssh/source.vala"
					return FALSE;
#line 2443 "source.c"
				}
#line 345 "../ssh/source.vala"
				_g_object_unref0 (_data_->op);
#line 2447 "source.c"
			}
		}
	}
#line 351 "../ssh/source.vala"
	_data_->result = NULL;
#line 351 "../ssh/source.vala"
	_g_free0 (_data_->fullpath);
#line 351 "../ssh/source.vala"
	seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 351 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 351 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 351 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 351 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2465 "source.c"
		}
	}
#line 351 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 351 "../ssh/source.vala"
	return FALSE;
#line 2472 "source.c"
}

static void
seahorse_ssh_source_import_public_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportPublicAsyncData, _data_);
#line 2492 "source.c"
}

void
seahorse_ssh_source_import_public_async (SeahorseSshSource* self,
                                         SeahorseSshKeyData* data,
                                         const gchar* filename,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (data != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportPublicAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_public_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (data);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_data_->data = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = g_strdup (filename);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_data_->filename = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_public_async_co (_data_);
#line 2544 "source.c"
}

gchar*
seahorse_ssh_source_import_public_finish (SeahorseSshSource* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	gchar* result;
	SeahorseSshSourceImportPublicAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2560 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2568 "source.c"
}

/**
     * Import a public key into a file.
     *
     * @param data The public key that needs to be imported.
     * @param filename The name of the file in which the key should be imported.
     * @param cancellable Allows the operation to be cancelled.
     */
static gboolean
seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_)
{
#line 361 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 361 "../ssh/source.vala"
		case 0:
#line 2585 "source.c"
		goto _state_0;
		default:
#line 361 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2590 "source.c"
	}
	_state_0:
#line 364 "../ssh/source.vala"
	if (_data_->data == NULL) {
#line 364 "../ssh/source.vala"
		_data_->_tmp1_ = TRUE;
#line 2597 "source.c"
	} else {
#line 364 "../ssh/source.vala"
		_data_->_tmp1_ = !seahorse_ssh_key_data_is_valid (_data_->data);
#line 2601 "source.c"
	}
#line 364 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 364 "../ssh/source.vala"
		_data_->_tmp0_ = TRUE;
#line 2607 "source.c"
	} else {
#line 364 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_key_data_get_rawdata (_data_->data);
#line 364 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 364 "../ssh/source.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 2615 "source.c"
	}
#line 364 "../ssh/source.vala"
	if (_data_->_tmp0_) {
#line 365 "../ssh/source.vala"
		_data_->_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Trying to import an invalid public key.");
#line 365 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp4_;
#line 365 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 365 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 365 "../ssh/source.vala"
		return FALSE;
#line 2629 "source.c"
	}
#line 367 "../ssh/source.vala"
	seahorse_ssh_key_data_filter_file (_data_->filename, _data_->data, NULL, &_data_->_inner_error0_);
#line 367 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 367 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 367 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 367 "../ssh/source.vala"
		return FALSE;
#line 2641 "source.c"
	}
#line 369 "../ssh/source.vala"
	_data_->_tmp5_ = seahorse_ssh_key_data_get_fingerprint (_data_->data);
#line 369 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 369 "../ssh/source.vala"
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 369 "../ssh/source.vala"
	_data_->result = _data_->_tmp7_;
#line 369 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 369 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 369 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 369 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2659 "source.c"
		}
	}
#line 369 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 369 "../ssh/source.vala"
	return FALSE;
#line 2666 "source.c"
}

/**
     * Returns a possible filename for a key.
     *
     * @param algo The type of the key
     */
gchar*
seahorse_ssh_source_new_filename_for_algorithm (SeahorseSshSource* self,
                                                SeahorseSshAlgorithm algo)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* type = NULL;
	gchar* _tmp3_;
	gchar* basename = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* filename = NULL;
	gchar* result;
#line 377 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 378 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_algorithm_to_string (algo);
#line 378 "../ssh/source.vala"
	_tmp0_ = _tmp1_;
#line 378 "../ssh/source.vala"
	if (_tmp0_ == NULL) {
#line 2698 "source.c"
		gchar* _tmp2_;
#line 378 "../ssh/source.vala"
		_tmp2_ = g_strdup ("unk");
#line 378 "../ssh/source.vala"
		_g_free0 (_tmp0_);
#line 378 "../ssh/source.vala"
		_tmp0_ = _tmp2_;
#line 2706 "source.c"
	}
#line 378 "../ssh/source.vala"
	_tmp3_ = _tmp0_;
#line 378 "../ssh/source.vala"
	_tmp0_ = NULL;
#line 378 "../ssh/source.vala"
	type = _tmp3_;
#line 379 "../ssh/source.vala"
	_tmp4_ = type;
#line 379 "../ssh/source.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 379 "../ssh/source.vala"
	_tmp6_ = _tmp5_;
#line 379 "../ssh/source.vala"
	_tmp7_ = g_strdup_printf ("id_%s", _tmp6_);
#line 379 "../ssh/source.vala"
	_tmp8_ = _tmp7_;
#line 379 "../ssh/source.vala"
	_g_free0 (_tmp6_);
#line 379 "../ssh/source.vala"
	basename = _tmp8_;
#line 381 "../ssh/source.vala"
	filename = NULL;
#line 2730 "source.c"
	{
		gint i = 0;
#line 382 "../ssh/source.vala"
		i = 0;
#line 2735 "source.c"
		{
			gboolean _tmp9_ = FALSE;
#line 382 "../ssh/source.vala"
			_tmp9_ = TRUE;
#line 382 "../ssh/source.vala"
			while (TRUE) {
#line 2742 "source.c"
				gchar* _tmp11_ = NULL;
				gchar* t = NULL;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
#line 382 "../ssh/source.vala"
				if (!_tmp9_) {
#line 2753 "source.c"
					gint _tmp10_;
#line 382 "../ssh/source.vala"
					_tmp10_ = i;
#line 382 "../ssh/source.vala"
					i = _tmp10_ + 1;
#line 2759 "source.c"
				}
#line 382 "../ssh/source.vala"
				_tmp9_ = FALSE;
#line 382 "../ssh/source.vala"
				if (!(i < G_MAXINT)) {
#line 382 "../ssh/source.vala"
					break;
#line 2767 "source.c"
				}
#line 383 "../ssh/source.vala"
				if (i == 0) {
#line 2771 "source.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 383 "../ssh/source.vala"
					_tmp12_ = basename;
#line 383 "../ssh/source.vala"
					_tmp13_ = g_strdup (_tmp12_);
#line 383 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 383 "../ssh/source.vala"
					_tmp11_ = _tmp13_;
#line 2782 "source.c"
				} else {
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 383 "../ssh/source.vala"
					_tmp14_ = basename;
#line 383 "../ssh/source.vala"
					_tmp15_ = g_strdup_printf ("%s.%d", _tmp14_, i);
#line 383 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 383 "../ssh/source.vala"
					_tmp11_ = _tmp15_;
#line 2794 "source.c"
				}
#line 383 "../ssh/source.vala"
				_tmp16_ = g_strdup (_tmp11_);
#line 383 "../ssh/source.vala"
				t = _tmp16_;
#line 384 "../ssh/source.vala"
				_tmp17_ = seahorse_ssh_source_get_base_directory (self);
#line 384 "../ssh/source.vala"
				_tmp18_ = _tmp17_;
#line 384 "../ssh/source.vala"
				_tmp19_ = t;
#line 384 "../ssh/source.vala"
				_tmp20_ = g_build_filename (_tmp18_, _tmp19_, NULL);
#line 384 "../ssh/source.vala"
				_g_free0 (filename);
#line 384 "../ssh/source.vala"
				filename = _tmp20_;
#line 386 "../ssh/source.vala"
				_tmp21_ = filename;
#line 386 "../ssh/source.vala"
				if (!g_file_test (_tmp21_, G_FILE_TEST_EXISTS)) {
#line 387 "../ssh/source.vala"
					_g_free0 (t);
#line 387 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 387 "../ssh/source.vala"
					break;
#line 2822 "source.c"
				}
#line 389 "../ssh/source.vala"
				_g_free0 (filename);
#line 389 "../ssh/source.vala"
				filename = NULL;
#line 382 "../ssh/source.vala"
				_g_free0 (t);
#line 382 "../ssh/source.vala"
				_g_free0 (_tmp11_);
#line 2832 "source.c"
			}
		}
	}
#line 392 "../ssh/source.vala"
	result = filename;
#line 392 "../ssh/source.vala"
	_g_free0 (basename);
#line 392 "../ssh/source.vala"
	_g_free0 (type);
#line 392 "../ssh/source.vala"
	_g_free0 (_tmp0_);
#line 392 "../ssh/source.vala"
	return result;
#line 2846 "source.c"
}

static void
seahorse_ssh_source_authorize_async_data_free (gpointer _data)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAuthorizeAsyncData, _data_);
#line 2858 "source.c"
}

void
seahorse_ssh_source_authorize_async (SeahorseSshSource* self,
                                     SeahorseSshKey* key,
                                     gboolean authorize,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKey* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (key != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAuthorizeAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_authorize_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (key);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->key);
#line 26 "../ssh/source.vala"
	_data_->key = _tmp1_;
#line 26 "../ssh/source.vala"
	_data_->authorize = authorize;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_authorize_async_co (_data_);
#line 2895 "source.c"
}

void
seahorse_ssh_source_authorize_finish (SeahorseSshSource* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return;
#line 2910 "source.c"
	}
}

/**
     * Adds/Removes a public key to/from the authorized keys.
     *
     * @param key The key that needs to be authorized.
     * @param authorize Whether the specified key needs to be (de-)authorized.
     */
static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 401 "../ssh/source.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 401 "../ssh/source.vala"
	return _data8_;
#line 2927 "source.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 401 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2937 "source.c"
		SeahorseSshSource* self;
#line 401 "../ssh/source.vala"
		self = _data8_->self;
#line 401 "../ssh/source.vala"
		_g_free0 (_data8_->to);
#line 401 "../ssh/source.vala"
		_g_free0 (_data8_->from);
#line 401 "../ssh/source.vala"
		_g_error_free0 (_data8_->err);
#line 401 "../ssh/source.vala"
		(_data8_->callback_target_destroy_notify == NULL) ? NULL : (_data8_->callback_target_destroy_notify (_data8_->callback_target), NULL);
#line 401 "../ssh/source.vala"
		_data8_->callback = NULL;
#line 401 "../ssh/source.vala"
		_data8_->callback_target = NULL;
#line 401 "../ssh/source.vala"
		_data8_->callback_target_destroy_notify = NULL;
#line 401 "../ssh/source.vala"
		_g_object_unref0 (_data8_->key);
#line 401 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 401 "../ssh/source.vala"
		g_slice_free (Block8Data, _data8_);
#line 2961 "source.c"
	}
}

static gboolean
_seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_authorize_async_co (self);
#line 402 "../ssh/source.vala"
	return result;
#line 2972 "source.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 434 "../ssh/source.vala"
	return self ? g_error_copy (self) : NULL;
#line 2980 "source.c"
}

static void*
__lambda6_ (Block8Data* _data8_)
{
	SeahorseSshSource* self;
	GSourceFunc _tmp13_;
	gpointer _tmp13__target;
	GDestroyNotify _tmp13__target_destroy_notify;
	GError* _inner_error0_ = NULL;
	void* result;
#line 416 "../ssh/source.vala"
	self = _data8_->self;
#line 2994 "source.c"
	{
		SeahorseSshKeyData* keydata = NULL;
		SeahorseSshKeyData* _tmp0_;
		SeahorseSshKeyData* _tmp1_;
		SeahorseSshKeyData* _tmp2_;
		SeahorseSshKeyData* _tmp3_;
		const gchar* _tmp5_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
#line 418 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_get_key_data (_data8_->key);
#line 418 "../ssh/source.vala"
		_tmp1_ = _tmp0_;
#line 418 "../ssh/source.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 418 "../ssh/source.vala"
		keydata = _tmp2_;
#line 419 "../ssh/source.vala"
		_tmp3_ = keydata;
#line 419 "../ssh/source.vala"
		if (_tmp3_ == NULL) {
#line 3017 "source.c"
			GError* _tmp4_;
#line 420 "../ssh/source.vala"
			_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't authorize empty key.");
#line 420 "../ssh/source.vala"
			_inner_error0_ = _tmp4_;
#line 420 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 3025 "source.c"
			goto __catch0_g_error;
		}
#line 423 "../ssh/source.vala"
		_tmp5_ = _data8_->from;
#line 423 "../ssh/source.vala"
		if (g_file_test (_tmp5_, G_FILE_TEST_EXISTS)) {
#line 3032 "source.c"
			const gchar* _tmp6_;
			SeahorseSshKeyData* _tmp7_;
#line 424 "../ssh/source.vala"
			_tmp6_ = _data8_->from;
#line 424 "../ssh/source.vala"
			_tmp7_ = keydata;
#line 424 "../ssh/source.vala"
			seahorse_ssh_key_data_filter_file (_tmp6_, NULL, _tmp7_, &_inner_error0_);
#line 424 "../ssh/source.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "../ssh/source.vala"
				_g_object_unref0 (keydata);
#line 3045 "source.c"
				goto __catch0_g_error;
			}
		}
#line 428 "../ssh/source.vala"
		_tmp8_ = _data8_->to;
#line 428 "../ssh/source.vala"
		seahorse_ssh_source_ensure_file_exists (self, _tmp8_);
#line 429 "../ssh/source.vala"
		_tmp9_ = _data8_->to;
#line 429 "../ssh/source.vala"
		_tmp10_ = keydata;
#line 429 "../ssh/source.vala"
		seahorse_ssh_key_data_filter_file (_tmp9_, _tmp10_, NULL, &_inner_error0_);
#line 429 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 3063 "source.c"
			goto __catch0_g_error;
		}
#line 432 "../ssh/source.vala"
		seahorse_ssh_key_refresh (_data8_->key);
#line 417 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 3070 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		GError* _tmp12_;
#line 417 "../ssh/source.vala"
		e = _inner_error0_;
#line 417 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 434 "../ssh/source.vala"
		_tmp11_ = e;
#line 434 "../ssh/source.vala"
		_tmp12_ = _g_error_copy0 (_tmp11_);
#line 434 "../ssh/source.vala"
		_g_error_free0 (_data8_->err);
#line 434 "../ssh/source.vala"
		_data8_->err = _tmp12_;
#line 417 "../ssh/source.vala"
		_g_error_free0 (e);
#line 3092 "source.c"
	}
	__finally0:
#line 417 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 417 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 417 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 417 "../ssh/source.vala"
		return NULL;
#line 3103 "source.c"
	}
#line 437 "../ssh/source.vala"
	_tmp13_ = _data8_->callback;
#line 437 "../ssh/source.vala"
	_tmp13__target = _data8_->callback_target;
#line 437 "../ssh/source.vala"
	_tmp13__target_destroy_notify = _data8_->callback_target_destroy_notify;
#line 437 "../ssh/source.vala"
	_data8_->callback = NULL;
#line 437 "../ssh/source.vala"
	_data8_->callback_target = NULL;
#line 437 "../ssh/source.vala"
	_data8_->callback_target_destroy_notify = NULL;
#line 437 "../ssh/source.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp13_, _tmp13__target, _tmp13__target_destroy_notify);
#line 438 "../ssh/source.vala"
	result = NULL;
#line 438 "../ssh/source.vala"
	return result;
#line 3123 "source.c"
}

static gpointer
___lambda6__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda6_ (self);
#line 416 "../ssh/source.vala"
	block8_data_unref (self);
#line 416 "../ssh/source.vala"
	return result;
#line 3135 "source.c"
}

static gboolean
seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_)
{
#line 401 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 401 "../ssh/source.vala"
		case 0:
#line 3145 "source.c"
		goto _state_0;
#line 401 "../ssh/source.vala"
		case 1:
#line 3149 "source.c"
		goto _state_1;
		default:
#line 401 "../ssh/source.vala"
		g_assert_not_reached ();
#line 3154 "source.c"
	}
	_state_0:
#line 401 "../ssh/source.vala"
	_data_->_data8_ = g_slice_new0 (Block8Data);
#line 401 "../ssh/source.vala"
	_data_->_data8_->_ref_count_ = 1;
#line 401 "../ssh/source.vala"
	_data_->_data8_->self = g_object_ref (_data_->self);
#line 401 "../ssh/source.vala"
	_g_object_unref0 (_data_->_data8_->key);
#line 401 "../ssh/source.vala"
	_data_->_data8_->key = _data_->key;
#line 401 "../ssh/source.vala"
	_data_->_data8_->_async_data_ = _data_;
#line 402 "../ssh/source.vala"
	_data_->_data8_->callback = _seahorse_ssh_source_authorize_async_co_gsource_func;
#line 402 "../ssh/source.vala"
	_data_->_data8_->callback_target = _data_;
#line 402 "../ssh/source.vala"
	_data_->_data8_->callback_target_destroy_notify = NULL;
#line 403 "../ssh/source.vala"
	_data_->_data8_->err = NULL;
#line 408 "../ssh/source.vala"
	if (_data_->authorize) {
#line 409 "../ssh/source.vala"
		_data_->_tmp0_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 409 "../ssh/source.vala"
		_g_free0 (_data_->_data8_->from);
#line 409 "../ssh/source.vala"
		_data_->_data8_->from = _data_->_tmp0_;
#line 410 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 410 "../ssh/source.vala"
		_g_free0 (_data_->_data8_->to);
#line 410 "../ssh/source.vala"
		_data_->_data8_->to = _data_->_tmp1_;
#line 3191 "source.c"
	} else {
#line 412 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 412 "../ssh/source.vala"
		_g_free0 (_data_->_data8_->from);
#line 412 "../ssh/source.vala"
		_data_->_data8_->from = _data_->_tmp2_;
#line 413 "../ssh/source.vala"
		_data_->_tmp3_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 413 "../ssh/source.vala"
		_g_free0 (_data_->_data8_->to);
#line 413 "../ssh/source.vala"
		_data_->_data8_->to = _data_->_tmp3_;
#line 3205 "source.c"
	}
#line 416 "../ssh/source.vala"
	_data_->_tmp4_ = g_thread_new ("authorize-async", ___lambda6__gthread_func, block8_data_ref (_data_->_data8_));
#line 416 "../ssh/source.vala"
	_data_->thread = _data_->_tmp4_;
#line 441 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 441 "../ssh/source.vala"
	return FALSE;
#line 3215 "source.c"
	_state_1:
	;
#line 443 "../ssh/source.vala"
	_data_->_tmp5_ = _data_->thread;
#line 443 "../ssh/source.vala"
	_data_->thread = NULL;
#line 443 "../ssh/source.vala"
	g_thread_join (_data_->_tmp5_);
#line 445 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_data8_->err;
#line 445 "../ssh/source.vala"
	if (_data_->_tmp6_ != NULL) {
#line 446 "../ssh/source.vala"
		_data_->_tmp7_ = _data_->_data8_->err;
#line 446 "../ssh/source.vala"
		_data_->_tmp8_ = _g_error_copy0 (_data_->_tmp7_);
#line 446 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 446 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 446 "../ssh/source.vala"
		_g_thread_unref0 (_data_->thread);
#line 446 "../ssh/source.vala"
		block8_data_unref (_data_->_data8_);
#line 446 "../ssh/source.vala"
		_data_->_data8_ = NULL;
#line 446 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 446 "../ssh/source.vala"
		return FALSE;
#line 3246 "source.c"
	}
#line 401 "../ssh/source.vala"
	_g_thread_unref0 (_data_->thread);
#line 401 "../ssh/source.vala"
	block8_data_unref (_data_->_data8_);
#line 401 "../ssh/source.vala"
	_data_->_data8_ = NULL;
#line 401 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 401 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 401 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 401 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3262 "source.c"
		}
	}
#line 401 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 401 "../ssh/source.vala"
	return FALSE;
#line 3269 "source.c"
}

static void
seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                        const gchar* filename)
{
	gint fd = 0;
#line 449 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 449 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 450 "../ssh/source.vala"
	fd = open (filename, O_WRONLY | O_CREAT, (mode_t) 0644);
#line 451 "../ssh/source.vala"
	close (fd);
#line 3285 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_find_key_by_fingerprint (SeahorseSshSource* self,
                                             const gchar* fingerprint)
{
	SeahorseSshKey* result;
#line 454 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "../ssh/source.vala"
	g_return_val_if_fail (fingerprint != NULL, NULL);
#line 3297 "source.c"
	{
		guint i = 0U;
#line 455 "../ssh/source.vala"
		i = (guint) 0;
#line 3302 "source.c"
		{
			gboolean _tmp0_ = FALSE;
#line 455 "../ssh/source.vala"
			_tmp0_ = TRUE;
#line 455 "../ssh/source.vala"
			while (TRUE) {
#line 3309 "source.c"
				GListStore* _tmp2_;
				SeahorseSshKey* key = NULL;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				SeahorseSshKey* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 455 "../ssh/source.vala"
				if (!_tmp0_) {
#line 3319 "source.c"
					guint _tmp1_;
#line 455 "../ssh/source.vala"
					_tmp1_ = i;
#line 455 "../ssh/source.vala"
					i = _tmp1_ + 1;
#line 3325 "source.c"
				}
#line 455 "../ssh/source.vala"
				_tmp0_ = FALSE;
#line 455 "../ssh/source.vala"
				_tmp2_ = self->priv->keys;
#line 455 "../ssh/source.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 455 "../ssh/source.vala"
					break;
#line 3335 "source.c"
				}
#line 456 "../ssh/source.vala"
				_tmp3_ = self->priv->keys;
#line 456 "../ssh/source.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, i);
#line 456 "../ssh/source.vala"
				key = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 457 "../ssh/source.vala"
				_tmp5_ = key;
#line 457 "../ssh/source.vala"
				_tmp6_ = seahorse_ssh_key_get_fingerprint (_tmp5_);
#line 457 "../ssh/source.vala"
				_tmp7_ = _tmp6_;
#line 457 "../ssh/source.vala"
				if (g_strcmp0 (_tmp7_, fingerprint) == 0) {
#line 458 "../ssh/source.vala"
					result = key;
#line 458 "../ssh/source.vala"
					return result;
#line 3355 "source.c"
				}
#line 455 "../ssh/source.vala"
				_g_object_unref0 (key);
#line 3359 "source.c"
			}
		}
	}
#line 462 "../ssh/source.vala"
	result = NULL;
#line 462 "../ssh/source.vala"
	return result;
#line 3367 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_construct (GType object_type)
{
	SeahorseSshSource * self = NULL;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) g_object_new (object_type, NULL);
#line 26 "../ssh/source.vala"
	return self;
#line 3378 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_new (void)
{
#line 26 "../ssh/source.vala"
	return seahorse_ssh_source_construct (SEAHORSE_SSH_TYPE_SOURCE);
#line 3386 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_label (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	gchar* _tmp0_;
#line 46 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 46 "../ssh/source.vala"
	_tmp0_ = g_strdup (_ ("OpenSSH keys"));
#line 46 "../ssh/source.vala"
	result = _tmp0_;
#line 46 "../ssh/source.vala"
	return result;
#line 3403 "source.c"
}

static void
seahorse_ssh_source_real_set_label (SeahorsePlace* base,
                                    const gchar* value)
{
	SeahorseSshSource* self;
#line 47 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 47 "../ssh/source.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY]);
#line 3415 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_description (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 51 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 51 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 51 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("OpenSSH: %s"), _tmp0_);
#line 51 "../ssh/source.vala"
	result = _tmp1_;
#line 51 "../ssh/source.vala"
	return result;
#line 3435 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_uri (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 55 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 55 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 55 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("openssh://%s"), _tmp0_);
#line 55 "../ssh/source.vala"
	result = _tmp1_;
#line 55 "../ssh/source.vala"
	return result;
#line 3455 "source.c"
}

static GIcon*
seahorse_ssh_source_real_get_icon (SeahorsePlace* base)
{
	GIcon* result;
	SeahorseSshSource* self;
	GThemedIcon* _tmp0_;
#line 59 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 59 "../ssh/source.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (GCR_ICON_HOME_DIRECTORY);
#line 59 "../ssh/source.vala"
	result = (GIcon*) _tmp0_;
#line 59 "../ssh/source.vala"
	return result;
#line 3472 "source.c"
}

static SeahorsePlaceCategory
seahorse_ssh_source_real_get_category (SeahorsePlace* base)
{
	SeahorsePlaceCategory result;
	SeahorseSshSource* self;
#line 63 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 63 "../ssh/source.vala"
	result = SEAHORSE_PLACE_CATEGORY_KEYS;
#line 63 "../ssh/source.vala"
	return result;
#line 3486 "source.c"
}

static GActionGroup*
seahorse_ssh_source_real_get_actions (SeahorsePlace* base)
{
	GActionGroup* result;
	SeahorseSshSource* self;
#line 67 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 67 "../ssh/source.vala"
	result = NULL;
#line 67 "../ssh/source.vala"
	return result;
#line 3500 "source.c"
}

static const gchar*
seahorse_ssh_source_real_get_action_prefix (SeahorsePlace* base)
{
	const gchar* result;
	SeahorseSshSource* self;
#line 71 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 71 "../ssh/source.vala"
	result = NULL;
#line 71 "../ssh/source.vala"
	return result;
#line 3514 "source.c"
}

static GMenuModel*
seahorse_ssh_source_real_get_menu_model (SeahorsePlace* base)
{
	GMenuModel* result;
	SeahorseSshSource* self;
#line 75 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 75 "../ssh/source.vala"
	result = NULL;
#line 75 "../ssh/source.vala"
	return result;
#line 3528 "source.c"
}

static gboolean
seahorse_ssh_source_real_get_show_if_empty (SeahorsePlace* base)
{
	gboolean result;
	SeahorseSshSource* self;
#line 79 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 79 "../ssh/source.vala"
	result = TRUE;
#line 79 "../ssh/source.vala"
	return result;
#line 3542 "source.c"
}

const gchar*
seahorse_ssh_source_get_base_directory (SeahorseSshSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 86 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 86 "../ssh/source.vala"
	result = _tmp0_;
#line 86 "../ssh/source.vala"
	return result;
#line 3558 "source.c"
}

static GObject *
seahorse_ssh_source_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseSshSource * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 89 "../ssh/source.vala"
	parent_class = G_OBJECT_CLASS (seahorse_ssh_source_parent_class);
#line 89 "../ssh/source.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 89 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 90 "../ssh/source.vala"
	_tmp0_ = g_get_home_dir ();
#line 90 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf ("%s/.ssh", _tmp0_);
#line 90 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 90 "../ssh/source.vala"
	self->priv->ssh_homedir = _tmp1_;
#line 93 "../ssh/source.vala"
	_tmp2_ = self->priv->ssh_homedir;
#line 93 "../ssh/source.vala"
	if (!g_file_test (_tmp2_, G_FILE_TEST_EXISTS)) {
#line 3590 "source.c"
		const gchar* _tmp3_;
#line 94 "../ssh/source.vala"
		_tmp3_ = self->priv->ssh_homedir;
#line 94 "../ssh/source.vala"
		if (g_mkdir (_tmp3_, 0700) != 0) {
#line 3596 "source.c"
			const gchar* _tmp4_;
#line 95 "../ssh/source.vala"
			_tmp4_ = self->priv->ssh_homedir;
#line 95 "../ssh/source.vala"
			g_warning ("source.vala:95: couldn't create .ssh directory: %s", _tmp4_);
#line 96 "../ssh/source.vala"
			return obj;
#line 3604 "source.c"
		}
	}
#line 100 "../ssh/source.vala"
	seahorse_ssh_source_monitor_ssh_homedir (self);
#line 89 "../ssh/source.vala"
	return obj;
#line 3611 "source.c"
}

static void
seahorse_ssh_source_class_init (SeahorseSshSourceClass * klass,
                                gpointer klass_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_parent_class = g_type_class_peek_parent (klass);
#line 26 "../ssh/source.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshSource_private_offset);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_source_get_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_source_set_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_ssh_source_constructor;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_source_finalize;
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_LABEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_URI_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ICON_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", SEAHORSE_PLACE_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY] = g_param_spec_string ("action-prefix", "action-prefix", "action-prefix", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY] = g_param_spec_boolean ("show-if-empty", "show-if-empty", "show-if-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3648 "source.c"
	/**
	     * The directory containing the SSH keys.
	     */
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY] = g_param_spec_string ("base-directory", "base-directory", "base-directory", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3654 "source.c"
}

static void
seahorse_ssh_source_gcr_collection_interface_init (GcrCollectionIface * iface,
                                                   gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_gcr_collection_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->get_length = (guint (*) (GcrCollection*)) seahorse_ssh_source_real_get_length;
#line 26 "../ssh/source.vala"
	iface->get_objects = (GList* (*) (GcrCollection*)) seahorse_ssh_source_real_get_objects;
#line 26 "../ssh/source.vala"
	iface->contains = (gboolean (*) (GcrCollection*, GObject*)) seahorse_ssh_source_real_contains;
#line 3669 "source.c"
}

static void
seahorse_ssh_source_seahorse_place_interface_init (SeahorsePlaceIface * iface,
                                                   gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_seahorse_place_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->load = (void (*) (SeahorsePlace*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_ssh_source_real_load;
#line 26 "../ssh/source.vala"
	iface->load_finish = (gboolean (*) (SeahorsePlace*, GAsyncResult*, GError**)) seahorse_ssh_source_load_finish;
#line 26 "../ssh/source.vala"
	iface->get_label = seahorse_ssh_source_real_get_label;
#line 26 "../ssh/source.vala"
	iface->set_label = seahorse_ssh_source_real_set_label;
#line 26 "../ssh/source.vala"
	iface->get_description = seahorse_ssh_source_real_get_description;
#line 26 "../ssh/source.vala"
	iface->get_uri = seahorse_ssh_source_real_get_uri;
#line 26 "../ssh/source.vala"
	iface->get_icon = seahorse_ssh_source_real_get_icon;
#line 26 "../ssh/source.vala"
	iface->get_category = seahorse_ssh_source_real_get_category;
#line 26 "../ssh/source.vala"
	iface->get_actions = seahorse_ssh_source_real_get_actions;
#line 26 "../ssh/source.vala"
	iface->get_action_prefix = seahorse_ssh_source_real_get_action_prefix;
#line 26 "../ssh/source.vala"
	iface->get_menu_model = seahorse_ssh_source_real_get_menu_model;
#line 26 "../ssh/source.vala"
	iface->get_show_if_empty = seahorse_ssh_source_real_get_show_if_empty;
#line 3702 "source.c"
}

static void
seahorse_ssh_source_instance_init (SeahorseSshSource * self,
                                   gpointer klass)
{
	GListStore* _tmp0_;
#line 26 "../ssh/source.vala"
	self->priv = seahorse_ssh_source_get_instance_private (self);
#line 38 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 40 "../ssh/source.vala"
	self->priv->monitor_handle = NULL;
#line 43 "../ssh/source.vala"
	_tmp0_ = g_list_store_new (SEAHORSE_SSH_TYPE_KEY);
#line 43 "../ssh/source.vala"
	self->priv->keys = _tmp0_;
#line 3720 "source.c"
}

static void
seahorse_ssh_source_finalize (GObject * obj)
{
	SeahorseSshSource * self;
#line 26 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 36 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 40 "../ssh/source.vala"
	_g_object_unref0 (self->priv->monitor_handle);
#line 43 "../ssh/source.vala"
	_g_object_unref0 (self->priv->keys);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (seahorse_ssh_source_parent_class)->finalize (obj);
#line 3737 "source.c"
}

/**
 * The {@link Place} where SSH keys are stored. By default that is ~/.ssh.
 * Basically, this becomes an interface to the SSH home directory.
 */
 G_GNUC_NO_INLINE static GType
seahorse_ssh_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshSource), 0, (GInstanceInitFunc) seahorse_ssh_source_instance_init, NULL };
	static const GInterfaceInfo gcr_collection_info = { (GInterfaceInitFunc) seahorse_ssh_source_gcr_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_place_info = { (GInterfaceInitFunc) seahorse_ssh_source_seahorse_place_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_ssh_source_type_id;
	seahorse_ssh_source_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshSource", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_ssh_source_type_id, gcr_collection_get_type (), &gcr_collection_info);
	g_type_add_interface_static (seahorse_ssh_source_type_id, SEAHORSE_TYPE_PLACE, &seahorse_place_info);
	SeahorseSshSource_private_offset = g_type_add_instance_private (seahorse_ssh_source_type_id, sizeof (SeahorseSshSourcePrivate));
	return seahorse_ssh_source_type_id;
}

GType
seahorse_ssh_source_get_type (void)
{
	static volatile gsize seahorse_ssh_source_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_source_type_id__once)) {
		GType seahorse_ssh_source_type_id;
		seahorse_ssh_source_type_id = seahorse_ssh_source_get_type_once ();
		g_once_init_leave (&seahorse_ssh_source_type_id__once, seahorse_ssh_source_type_id);
	}
	return seahorse_ssh_source_type_id__once;
}

static void
_vala_seahorse_ssh_source_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_label ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_description ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_URI_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_uri ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ICON_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_icon ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_enum (value, seahorse_place_get_category ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_actions ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_place_get_action_prefix ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_menu_model ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_boolean (value, seahorse_place_get_show_if_empty ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_ssh_source_get_base_directory (self));
#line 26 "../ssh/source.vala"
		break;
#line 3840 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3846 "source.c"
	}
}

static void
_vala_seahorse_ssh_source_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		seahorse_place_set_label ((SeahorsePlace*) self, g_value_get_string (value));
#line 26 "../ssh/source.vala"
		break;
#line 3866 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3872 "source.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

